"use strict"
this.name = "Teleportation Drive";
this.author = "Reval";
this.license = "CC-BY-NC-SA 4.0";
this.version = "1.0";
this.description = "FE Shipyards will link your ASC and Injector circuitry to the Hyperspace motor, allowing the formation of a miniature wormhole between the ship and its destination station. With a tap of the 'i' button, space is folded and transport is instantaneous. We call it the T-drive.";


this.startUp = function() {
	this.$tpLastDest = player.ship.position;
	// is TP drive installed?
	this.$tpHasEq = false;
	// has compass target changed?
	this.$tpChanged = false;
}


this.shipWillLaunchFromStation = function() {
	// establish once whether ship has the TP-drive
	this.$tpHasEq = (player.ship.equipmentStatus ("EQ_TP_DRIVE") === "EQUIPMENT_OK");
	if (this.$tpHasEq) {
		// set up 'destination monitor'
		if(!this.$tpTimer) this.$tpTimer=new Timer(this,this._tpMonitorDestination.bind(this),0,0.25);
		// set up 'injectors' monitor
		if(!this.$tpTimer2) this.$tpTimer2=new Timer(this,this._tpMonitorInjectors.bind(this),0,0.25);
		this.$tpChanged = false;
	}
}


this.playerBoughtEquipment = function(equipment, paid) {
	var pc = player.consoleMessage;
	var ps = player.ship;
	if (equipment == "EQ_TP_DRIVE") {
		pc("Re-routing H-circuits for T-drive.",9);
		pc("Teleportation Drive is operative.",9);
		// decicredits, so convert
		this.$tpCost = paid/10;
	}
	if (equipment == "EQ_TP_DRIVE_REM") {
		ps.removeEquipment("EQ_TP_DRIVE");
		ps.removeEquipment("EQ_TP_DRIVE_REM");
		pc("Teleportation Drive removed.",9);
		player.credits += this.$tpCost;
		pc(this.$tpCost + "cr refunded.",9);
	}
}


this._tpMonitorDestination = function() {
	if (this.$tpHasEq) {	
		try {
			var pc = player.consoleMessage;
			var ps = player.ship;
			var psd = ps.compassTarget;
			var psdn = psd.displayName;
			var last = this.$tpLastDest;
			// if destination changed, note it
			if ((last != psd) && (psd != null)) {
				this.$tpChanged = true;
				var c = ps.messageGuiTextColor;
				ps.messageGuiTextColor = "purpleColor";
				pc("TP: "+psdn,9);
				this.$tpLastDest = psd;
				ps.messageGuiTextColor = c;
		}
		} finally {}
	}
}


this._tpMonitorInjectors = function() {
	if (this.$tpHasEq) {
		var ps = player.ship;
		var pc = player.consoleMessage;
		if (this.$tpChanged) 
			if (ps.injectorsEngaged) {
				this.$tpChanged = false;
				// report T-drive start
				var c = ps.messageGuiTextColor;
				ps.messageGuiTextColor = "purpleColor";
				pc("T-drive engaged.",9);
				// Teleport
				ps.position = ps.compassTarget.position;
				// report arrival
				pc("Arrived at "+ps.compassTarget.displayName,9);
				ps.messageGuiTextColor = c;
			}
	}
}
